import { Component, ComponentClass, ConsumerProps, ProviderProps, ReactElement, ReactNodeArray, ReactPortal, StatelessComponent } from 'react';
import { LocalizeState } from './types';
export declare const createLocalize: (language: string, languages: string[]) => {
    LocalizeProvider: new (props: import("dakpan/lib/types").DakpanProviderProps) => {
        componentWillUnmount(): void;
        render(): ReactElement<ProviderProps<LocalizeState>>;
        getState: () => Readonly<LocalizeState>;
        setState<K extends "translations" | "language" | "languages">(state: LocalizeState | Pick<LocalizeState, K> | ((prevState: Readonly<LocalizeState>, props: Readonly<import("dakpan/lib/types").DakpanProviderProps>) => LocalizeState | Pick<LocalizeState, K> | null) | null, callback?: (() => void) | undefined): void;
        forceUpdate(callBack?: (() => void) | undefined): void;
        readonly props: Readonly<{
            children?: string | number | boolean | {} | ReactElement<any> | ReactNodeArray | ReactPortal | null | undefined;
        }> & Readonly<import("dakpan/lib/types").DakpanProviderProps>;
        state: Readonly<LocalizeState>;
        context: any;
        refs: {
            [key: string]: Element | Component<any, {}, any>;
        };
    };
    LocalizeConsumer: ({ children }: import("dakpan/lib/types").DakpanConsumerProps<LocalizeState, {
        setLanguage: (language: string) => () => {
            language: string;
        };
    }>) => ReactElement<ConsumerProps<LocalizeState>>;
    withLocalize: <H>(map: (state: LocalizeState, actions: import("dakpan/lib/types").MappedActions<LocalizeState, {
        setLanguage: (language: string) => () => {
            language: string;
        };
    }>) => H) => <P>(component: ComponentClass<P & H, {}> | StatelessComponent<P & H>) => (props: Pick<P, Exclude<keyof P, keyof H>>) => ReactElement<import("dakpan/lib/types").DakpanConsumerProps<LocalizeState, {
        setLanguage: (language: string) => () => {
            language: string;
        };
    }>>;
    TranslationProvider: ({ translations, children }: import("./types").ProviderProps) => ReactElement<ConsumerProps<LocalizeState>>;
    withTranslations: (translations: import("./types").Translations) => <P>(component: ComponentClass<P, {}> | StatelessComponent<P>) => (props: P) => ReactElement<import("./types").ProviderProps>;
    Translate: ({ id, data }: import("./types").TranslateProps) => ReactElement<ConsumerProps<LocalizeState>>;
};
