"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dakpan_1 = require("dakpan");
const createProvider_1 = require("./createProvider");
const createTranslate_1 = require("./createTranslate");
const withTranslations_1 = require("./withTranslations");
exports.createLocalize = (language, languages) => {
    if (!languages.length) {
        throw new Error(`You may not provide 'createLocalize' with an empty 'languages' array`);
    }
    else if (languages.indexOf(language) === -1) {
        language = languages[0];
    }
    const { Provider, Consumer, withConsumer, context } = dakpan_1.createDakpan({
        language,
        languages,
        translations: {}
    })({
        setLanguage: (language) => () => ({
            language
        })
    });
    const TranslationProvider = createProvider_1.createProvider(context);
    return {
        LocalizeProvider: Provider,
        LocalizeConsumer: Consumer,
        withLocalize: withConsumer,
        TranslationProvider,
        withTranslations: withTranslations_1.withTranslations(TranslationProvider),
        Translate: createTranslate_1.createTranslate(context)
    };
};
//# sourceMappingURL=createLocalize.js.map