"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const flattenTranslation_1 = require("./flattenTranslation");
exports.createProvider = (context) => {
    const TranslationProvider = ({ translations, children }) => react_1.createElement(context.Consumer, {
        children: ({ language, languages, translations: t }) => react_1.createElement(context.Provider, {
            value: {
                language,
                languages,
                translations: Object.assign({}, t, flattenTranslation_1.flattenTranslation(translations))
            },
            children
        })
    });
    return TranslationProvider;
};
//# sourceMappingURL=createProvider.js.map