"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
exports.createTranslate = (context) => {
    const Translate = ({ id, data = {} }) => react_1.createElement(context.Consumer, {
        children: ({ language, languages, translations }) => {
            const index = languages.indexOf(language);
            const translation = translations[id];
            if (!translation) {
                throw new Error(`Translation with id '${id}' not found`);
            }
            else if (index === -1 || translation.length <= index) {
                throw new Error(`Language '${language}' for translation '${id}' not found`);
            }
            let result = translation[index];
            Object.keys(data).forEach((key) => result = result.replace(new RegExp('\\{' + key + '}', 'g'), data[key]));
            return result;
        }
    });
    return Translate;
};
//# sourceMappingURL=createTranslate.js.map